function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { PrimaryColumn, Entity, Index, JoinColumn, Column, ManyToOne } from "typeorm";
import { User } from "./user.js";
import { id } from "../id.js";
export const webhookEventTypes = [
    "mention",
    "unfollow",
    "follow",
    "followed",
    "note",
    "reply",
    "renote",
    "reaction"
];
export let Webhook = class Webhook {
    id;
    createdAt;
    userId;
    user;
    name;
    on;
    url;
    secret;
    active;
    /**
	 * 直近のリクエスト送信日時
	 */ latestSentAt;
    /**
	 * 直近のリクエスト送信時のHTTPステータスコード
	 */ latestStatus;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], Webhook.prototype, "id", void 0);
_ts_decorate([
    Column("timestamp with time zone", {
        comment: "The created date of the Antenna."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], Webhook.prototype, "createdAt", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        comment: "The owner ID."
    }),
    _ts_metadata("design:type", Object)
], Webhook.prototype, "userId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], Webhook.prototype, "user", void 0);
_ts_decorate([
    Column("varchar", {
        length: 128,
        comment: "The name of the Antenna."
    }),
    _ts_metadata("design:type", String)
], Webhook.prototype, "name", void 0);
_ts_decorate([
    Index(),
    Column("varchar", {
        length: 128,
        array: true,
        default: "{}"
    }),
    _ts_metadata("design:type", Array)
], Webhook.prototype, "on", void 0);
_ts_decorate([
    Column("varchar", {
        length: 1024
    }),
    _ts_metadata("design:type", String)
], Webhook.prototype, "url", void 0);
_ts_decorate([
    Column("varchar", {
        length: 1024
    }),
    _ts_metadata("design:type", String)
], Webhook.prototype, "secret", void 0);
_ts_decorate([
    Index(),
    Column("boolean", {
        default: true
    }),
    _ts_metadata("design:type", Boolean)
], Webhook.prototype, "active", void 0);
_ts_decorate([
    Column("timestamp with time zone", {
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Webhook.prototype, "latestSentAt", void 0);
_ts_decorate([
    Column("integer", {
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Webhook.prototype, "latestStatus", void 0);
Webhook = _ts_decorate([
    Entity()
], Webhook);
